/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;namespace PluginIdea.ContexMenuSystem{public class UndoRedoType{public const int MOVE = 1;public const int ROTATE = 2;public const int ADD = 3;public const int REMOVE = 4;}public class UndoRedoItemDataBase{public int type;public FreeControllerV3 fv3;public virtual string TStr(){return "";}}public class UndoRedoMoveItemData : UndoRedoItemDataBase{public Vector3 position;public override string TStr(){return $"type:{type}curPos:{fv3.transform.position}pos:{position}";}}public class UndoRedoRotateItemData : UndoRedoItemDataBase{public Vector3 beginEuler;public Vector3 endEuler;public override string TStr(){return $"type:{type}curRot:{fv3.transform.eulerAngles}pos:{beginEuler}";}}public class UndoRedoAddItemData : UndoRedoItemDataBase{public string atomType;public AtomInfo atomInfo;public Vector3 position;public Vector3 rotation;}public class UndoRedoRemoveItemData : UndoRedoItemDataBase{public string atomType;public AtomInfo atomInfo;public Vector3 position;public Vector3 rotation;}public class UndoRedoData{private Stack<UndoRedoItemDataBase> undosStack = new Stack<UndoRedoItemDataBase>(GlobalSetting.stackCapcity);private Stack<UndoRedoItemDataBase> redoStack = new Stack<UndoRedoItemDataBase>(GlobalSetting.stackCapcity);public int UndoStackSize{get{return undosStack.Count;}}public void ClearRedoStack(){redoStack.Clear();}public void ClearUndoStack(){undosStack.Clear();}public UndoRedoItemDataBase GetTopItem(){return undosStack.Peek();}private void StackCapcityLimitFromEnd(Stack<UndoRedoItemDataBase> stack, int limit){if (stack.Count > limit){var list = new List<UndoRedoItemDataBase>();int i = 0;while (i < limit && stack.Count > 0){i++;list.Add(stack.Pop());}stack.Clear();list.Reverse();foreach (var item in list){stack.Push(item);}}}public void UndoPush(UndoRedoItemDataBase itemData){if(!ContexMenuSystem.isPaidVersion) StackCapcityLimitFromEnd(undosStack, 10);undosStack.Push(itemData);}public void RedoPush(UndoRedoItemDataBase itemData){redoStack.Push(itemData);}public UndoRedoItemDataBase UndoPop(){if (undosStack.Count == 0) return null;UndoRedoItemDataBase itemData = undosStack.Pop();redoStack.Push(itemData);return itemData;}public UndoRedoItemDataBase RedoPop(){if (redoStack.Count == 0) return null;UndoRedoItemDataBase itemData = redoStack.Pop();undosStack.Push(itemData);return itemData;}void PrintTheElementOfStackWithOneLine(Stack<UndoRedoItemDataBase> stack){string s = "";Debug.Log("======================");foreach (var item in stack){s += $"{item.TStr()}\n";}Debug.Log(s);}private string GetTypeName(int type){switch (type){case 1: return "Move";case 2: return "Rotate";case 3: return "Add";case 4: return "Delete";default:break;}return "";}}}