/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;using System.Linq;using SimpleJSON;using MVR.FileManagementSecure;namespace PluginIdea.ContexMenuSystem{public class SettingModule : CMModuleBase{private List<string> operateModeStrings = new List<string>{"Double Hand", "Single Hand Left", "Single Hand Right"};private JSONStorableFloat mouseMoveTriggerSensitivity;private JSONStorableFloat mouseHoldTriggerSensitivity;private JSONStorableStringChooser operateMode;private JSONStorableBool disableOnPlayMode;private JSONStorableBool isUseLMBClick;private JSONStorableBool isIgnoreHiddenAtoms;private JSONStorableBool showHitNormal;private JSONStorableBool selectAtomWhenAdded;private JSONStorableBool autoFocusWhenAdded;private JSONStorableFloat vrMenuDistance;private JSONStorableFloat uiScale;private JSONStorableBool enableCustomActionMenuGroup;private JSONStorableBool enableOpenPluginMenuGroup;private JSONStorableBool enableOpenUISelectorMenuGroup;private JSONStorableBool enablePhysicsMenuGroup;private JSONStorableBool enablePluginAddMenuGroup;private JSONStorableBool enableEditMenuGroup;private JSONStorableBool enableSelectMenuGroup;private JSONStorableBool enableViewAlignMenuGroup;private JSONStorableBool enableUndoRedoMenuGroup;private JSONStorableBool isWorldSpaceAlign;private JSONStorableBool isAtomOnly;public SettingModule(ContexMenuSystem ower){this.ower = ower;}public override void Init(){EventInit();if (!ContexMenuSystem.isPaidVersion){var btn = Utils.SetupButton(ower, Location.GetStr(Location.OpenMainPage), () =>{if (Location.IsChinease) Application.OpenURL(@"https:\/\/afdian.net/p/6f6685ceae9211ed8c8952540025c377");else Application.OpenURL(@"https:\/\/www.patreon.com/PluginIdea/about");}, false, true);btn.buttonImage.color = Color.yellow;Utils.SetupSpacer(ower, 30, false);}Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.GlobalSettingSubtitle), 40, false);Utils.SetupTwinButton(ower, Location.GetStr(Location.LoadPreset), GlobalSetting.LoadAsPreset, Location.GetStr(Location.SavePreset), GlobalSetting.SaveAsPreset, false);Utils.SetupSpacer(ower, 20, false);Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.TriggerSSubtitle), 35, false);mouseMoveTriggerSensitivity = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MouseMoveDetaTriggerSensitivity), 5f, 1f, 20f, false, true);mouseMoveTriggerSensitivity.setCallbackFunction = (val) =>{GlobalSetting.mouseMoveTriggerSenserty = val;};mouseHoldTriggerSensitivity = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MouseHoldTriggerSensitivity), 0.2f, 0.1f, 1f, false, true);mouseHoldTriggerSensitivity.setCallbackFunction = (val) =>{GlobalSetting.mouseHoldTimeTriggerSensitivity = val;};Utils.SetupSpacer(ower, 10, false);Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.OthersSubtitle), 35, false);uiScale = Utils.SetupSliderFloat(ower, Location.GetStr(Location.UIScale), 1f, 0.25f, 5f, false, true);uiScale.setCallbackFunction = (val) =>{ower.PopCanvas.GetComponent<CanvasScaler>().scaleFactor = val;};isUseLMBClick = Utils.SetupToggle(ower, Location.GetStr(Location.IsUseLMBClick), true, false, true);isUseLMBClick.setCallbackFunction = (val) =>{GlobalSetting.isUseLMBClick = val;};isIgnoreHiddenAtoms = Utils.SetupToggle(ower, Location.GetStr(Location.IsIgnoreHiddenAtoms), false, false, true);isIgnoreHiddenAtoms.setCallbackFunction = (val) =>{GlobalSetting.isIgnoreHiddenAtoms = val;};disableOnPlayMode = Utils.SetupToggle(ower, Location.GetStr(Location.IsDisableOnPlayMode), false, false, true);disableOnPlayMode.setCallbackFunction = (val) =>{GlobalSetting.disableOnPlayMode = val;};selectAtomWhenAdded = Utils.SetupToggle(ower, Location.GetStr(Location.SelectAtomWhenAdded), true, false, true);selectAtomWhenAdded.setCallbackFunction = (val) =>{GlobalSetting.selectAtomWhenAdded = val;};autoFocusWhenAdded = Utils.SetupToggle(ower, Location.GetStr(Location.AutoFocusWhenSelected), false, false, true);autoFocusWhenAdded.setCallbackFunction = (val) =>{GlobalSetting.autofocusWhenSelected = val;};Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.MenuGroupSubtitle), 40, false);Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.SceneMenuGroupSubtitle), 35, false);enableCustomActionMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableCustomActionsMenuGroup), true, false, true);enableCustomActionMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableCustomActionMenuGroup = val;};enableOpenPluginMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableOpenPluginMenuGroup), true, false, true);enableOpenPluginMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableOpenPluginMenuGroup = val;};enableOpenUISelectorMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableOpenUISelectorMenuGroup), true, false, true);enableOpenUISelectorMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableOpenUISelectorMenuGroup = val;};enablePhysicsMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnablePhysicsMenuGroup), true, false, true);enablePhysicsMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enablePhysicsMenuGroup = val;};enablePluginAddMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnablePluginAddMenuGroup), false, false, ContexMenuSystem.isPaidVersion);enablePluginAddMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enablePluginAddMenuGroup = val;};Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.UndoRedoSubtitle), 40, true);if (!ContexMenuSystem.isPaidVersion){Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.UndoRedoFreeLog), 100, true);}Utils.SetupSpacer(ower, 20, true);enableViewAlignMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableViewAlignMenuGroup), false, false, true);enableViewAlignMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableViewAlignMenuGroup = val;};enableEditMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableEditMenuGroup), true, false, true);enableEditMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableEditMenuGroup = val;};enableSelectMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableSelectMenuGroup), true, false, true);enableSelectMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableSelectMenuGroup = val;};enableUndoRedoMenuGroup = Utils.SetupToggle(ower, Location.GetStr(Location.EnableUndoRedoMenuGroup), false, false, true);enableUndoRedoMenuGroup.setCallbackFunction = (val) =>{GlobalSetting.enableUndoRedoMenuGroup = val;};Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.MenuGroupDetailSubtitle), 40, true);Utils.SetupInfoTextNoScroll(ower, Location.GetStr(Location.ViewAlignDetailSubtitle), 35, true);isWorldSpaceAlign = Utils.SetupToggle(ower, Location.GetStr(Location.ViewAlignInWorldSpace), false, true, true);isWorldSpaceAlign.setCallbackFunction = (val) =>{GlobalSetting.isAlignWithWorldSpace = val;};isAtomOnly = Utils.SetupToggle(ower, Location.GetStr(Location.IsAtomOnly), true, true, true);isAtomOnly.setCallbackFunction = (val) =>{GlobalSetting.isOnlyAtom = val;};Utils.SetupInfoTextNoScroll(this.ower, Location.GetStr(Location.VRSubtitle), 35, false);operateMode = Utils.SetupStringChooser(ower, Location.GetStr(Location.OperateMode), operateModeStrings, false, ContexMenuSystem.isPaidVersion);operateMode.setCallbackFunction = (val) =>{GlobalSetting.currentOptMode = operateModeStrings.IndexOf(val);};vrMenuDistance = Utils.SetupSliderFloat(ower, Location.GetStr(Location.MenuDistance), 0.4f, 0.3f, 0.6f, false, true);vrMenuDistance.setCallbackFunction = (val) =>{GlobalSetting.menuDistance = val;};}private void EventInit(){EventBus.Instance.AddEventHandler<JSONNode>(EventID.OnPresetLoadSuccessEvent, OnPresetLoadSuccessed);}private void OnPresetLoadSuccessed(JSONNode obj){mouseMoveTriggerSensitivity.val = float.Parse(obj["mouseMoveTriggerSenserty"].Value);mouseHoldTriggerSensitivity.val = float.Parse(obj["mouseHoldTimeTriggerSensitivity"].Value);int oindex = int.Parse(obj["currentOptMode"].Value);operateMode.val = operateModeStrings[oindex];disableOnPlayMode.val = bool.Parse(obj["disableOnPlayMode"].Value);isUseLMBClick.val = bool.Parse(obj["isUseLMBClick"].Value);selectAtomWhenAdded.val = bool.Parse(obj["selectAtomWhenAdded"].Value);autoFocusWhenAdded.val = bool.Parse(obj["autofocusWhenSelected"].Value);vrMenuDistance.val = float.Parse(obj["menuDistance"].Value);uiScale.val = float.Parse(obj["uiscale"].Value);enableCustomActionMenuGroup.val = bool.Parse(obj["enableCustomActionMenuGroup"].Value);enableOpenPluginMenuGroup.val = bool.Parse(obj["enableOpenPluginMenuGroup"].Value);enableOpenUISelectorMenuGroup.val = bool.Parse(obj["enableOpenUISelectorMenuGroup"].Value);enablePhysicsMenuGroup.val = bool.Parse(obj["enablePhysicsMenuGroup"].Value);enablePluginAddMenuGroup.val = bool.Parse(obj["enablePluginAddMenuGroup"].Value);enableViewAlignMenuGroup.val = bool.Parse(obj["enableViewAlignMenuGroup"].Value);enableEditMenuGroup.val = bool.Parse(obj["enableEditMenuGroup"].Value);enableSelectMenuGroup.val = bool.Parse(obj["enableSelectMenuGroup"].Value);enableUndoRedoMenuGroup.val = bool.Parse(obj["enableUndoRedoMenuGroup"].Value);isWorldSpaceAlign.val = bool.Parse(obj["isAlignWithWorldSpace"].Value);isAtomOnly.val = bool.Parse(obj["isOnlyAtom"].Value);}public override void OnReApplyUIParameter(){isUseLMBClick.setCallbackFunction(isUseLMBClick.val);selectAtomWhenAdded.setCallbackFunction(selectAtomWhenAdded.val);autoFocusWhenAdded.setCallbackFunction(autoFocusWhenAdded.val);enableCustomActionMenuGroup.setCallbackFunction(enableCustomActionMenuGroup.val);enableOpenPluginMenuGroup.setCallbackFunction(enableOpenPluginMenuGroup.val);enableOpenUISelectorMenuGroup.setCallbackFunction(enableOpenUISelectorMenuGroup.val);enablePhysicsMenuGroup.setCallbackFunction(enablePhysicsMenuGroup.val);enablePluginAddMenuGroup.setCallbackFunction(enablePluginAddMenuGroup.val);enableViewAlignMenuGroup.setCallbackFunction(enableViewAlignMenuGroup.val);enableEditMenuGroup.setCallbackFunction(enableEditMenuGroup.val);enableSelectMenuGroup.setCallbackFunction(enableSelectMenuGroup.val);enableUndoRedoMenuGroup.setCallbackFunction(enableUndoRedoMenuGroup.val);disableOnPlayMode.setCallbackFunction(disableOnPlayMode.val);operateMode.setCallbackFunction(operateMode.val);isWorldSpaceAlign.setCallbackFunction(isWorldSpaceAlign.val);vrMenuDistance.setCallbackFunction(vrMenuDistance.val);isAtomOnly.setCallbackFunction(isAtomOnly.val);uiScale.setCallbackFunction(uiScale.val);}public override void OnUpdate(){}public override void UnInit(){EventBus.Instance.RemoveEventHandler<JSONNode>(EventID.OnPresetLoadSuccessEvent, OnPresetLoadSuccessed);}}}