/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using System.Collections.Generic;using System;using UnityEngine.EventSystems;using UnityEngine.UI;using UnityEngine.Events;using System.Linq;namespace PluginIdea.ContexMenuSystem{public class RecordData{public int id;public Vector3 pos;public Vector3 rot;}public class UndoRedoMoudule : CMModuleBase{private UnDoReDoManager unDoReDoManager = new UnDoReDoManager();private List<string> lastAtomUids = new List<string>();private Dictionary<int, RecordData> dic_id2LastRecordDat = new Dictionary<int, RecordData>();private int checkFreq = 1;private float lastAtomSelectCheckTimer;private float checkdur;private bool isBeginDrag;public UndoRedoMoudule(ContexMenuSystem ower){this.ower = ower;checkdur = 1f / checkFreq;}public override void Init(){EventBus.Instance.AddEventHandler(EventID.OnUndoEvent, OnUndo);EventBus.Instance.AddEventHandler(EventID.OnRedoEvent, OnRedo);EventBus.Instance.AddEventHandler<CommonRecordInfo>(EventID.OnRecordEvent, OnRecord);}private float dragBeginTime;public override void OnUpdate(){lastAtomSelectCheckTimer += Time.deltaTime;if (lastAtomSelectCheckTimer > checkdur){checkdur = 0;Atom satom = SuperController.singleton.GetSelectedAtom();if (satom != null && satom != AtomSelectOpt.lastSelectAtom){AtomSelectOpt.lastSelectAtom = satom;}var allContorls = SuperController.singleton.GetAllFreeControllers();var controllers = allContorls.Where(x => x == x.containingAtom.mainController).ToList();if (Input.GetMouseButtonDown(0)){isBeginDrag = true;dragBeginTime = Time.time;dic_id2LastRecordDat.Clear();controllers.ForEach(ctr =>{int id = ctr.GetInstanceID();if (!dic_id2LastRecordDat.ContainsKey(id)){dic_id2LastRecordDat.Add(id, new RecordData(){id = id,                                pos = ctr.transform.position,                                rot = ctr.transform.eulerAngles});}});}else if (isBeginDrag && Input.GetMouseButtonUp(0)){isBeginDrag = false;float dur = Time.time - dragBeginTime;if (dur > 0.05f || dur == 0){controllers.ForEach(ctr =>{int id = ctr.GetInstanceID();if (dic_id2LastRecordDat.ContainsKey(id)){Vector3 lpos = dic_id2LastRecordDat[id].pos;float dis = (ctr.transform.position - lpos).magnitude;if (dis > 0.01f){OnRecord(new CommonRecordInfo(){type = UndoRedoType.MOVE,                                        fv3 = ctr,                                        pos = lpos,});}Vector3 lrot = dic_id2LastRecordDat[id].rot;bool deltaAngle = false;Vector3 eulerAngles = ctr.transform.eulerAngles;if (lrot != Vector3.zero || eulerAngles != Vector3.zero){deltaAngle = Mathf.Abs(lrot.x - eulerAngles.x)> 1 || Mathf.Abs(lrot.y - eulerAngles.y) > 1 || Mathf.Abs(lrot.z - eulerAngles.z) > 1;}if (deltaAngle){OnRecord(new CommonRecordInfo(){type = UndoRedoType.ROTATE,                                        fv3 = ctr,                                        beginRot = lrot,                                        endRot = eulerAngles});}}});}}}if (Input.GetKey(KeyCode.LeftControl)){if (Input.GetKeyDown(KeyCode.Z))                    OnUndo();else if (Input.GetKeyDown(KeyCode.Y))                    OnRedo();}}private void OnUndo(){unDoReDoManager.Undo();}private void OnRedo(){unDoReDoManager.Redo();}private void OnRecord(CommonRecordInfo recordInfo){unDoReDoManager.Record(recordInfo);}public override void UnInit(){EventBus.Instance.RemoveEventHandler(EventID.OnUndoEvent, OnUndo);EventBus.Instance.RemoveEventHandler(EventID.OnRedoEvent, OnRedo);EventBus.Instance.RemoveEventHandler<CommonRecordInfo>(EventID.OnRecordEvent, OnRecord);}}}